## Name

ctdbd — The CTDB cluster daemon

## Synopsis

`ctdbd` [`OPTION`...]

## DESCRIPTION

ctdbd is the main CTDB daemon.

Note that ctdbd is not usually invoked directly. It is invoked via ctdbd_wrapper(1) or via the initscript.

See ctdb(7) for an overview of CTDB.

## GENERAL OPTIONS

-d, --debug=`DEBUGLEVEL`

  This option sets the debug level to DEBUGLEVEL, which controls what will be written by the logging subsystem. The default is 2.

  See the DEBUG LEVELS section in ctdb(7) for more information.

--dbdir=`DIRECTORY`

  DIRECTORY on local storage where ctdbd keeps a local copy of TDB databases. This directory is local for each node and should not be stored on the shared cluster filesystem.

  Defaults to `/usr/local/var/lib/ctdb`.

--dbdir-persistent=`DIRECTORY`

  DIRECTORY on local storage where ctdbd keeps a local copy of persistent TDB databases. This directory is local for each node and should not be stored on the shared cluster filesystem.

  Defaults to `/usr/local/var/lib/ctdb/persistent`.

--dbdir-state=`DIRECTORY`

  DIRECTORY on local storage where ctdbd keep internal state TDB files. This directory is local for each node and should not be stored on the shared cluster filesystem.

  Defaults to `/usr/local/var/lib/ctdb/state`.

--event-script-dir=`DIRECTORY`

  DIRECTORY where the CTDB event scripts are stored. See the EVENT SCRIPTS section in ctdb(7) for more information.

  Default is `CTDB_BASE`/events.d, so usually `/usr/local/etc/ctdb/events.d`, which is part of the CTDB installation.

--listen=`IPADDR`

  IPADDR is the private IP address that ctdbd will bind to.

  By default ctdbd will select the first address from the nodes list that in can bind to. See also --nlist.

  This option is only required when automatic address detection can not be used. This can be the case when running multiple ctdbd daemons/nodes on the same physical host (usually for testing), using InfiniBand for the private network or on Linux when sysctl net.ipv4.ip_nonlocal_bind=1.

--logging=`STRING`

  STRING specifies where ctdbd will write its log. The default is file:`/usr/local/var/log/log.ctdb`.

  Valid values are:

  file:`FILENAME`

    FILENAME where ctdbd will write its log. This is usually `/usr/local/var/log/log.ctdb`.

  syslog[:`METHOD`]

    CTDB will log to syslog. By default this will use the syslog(3) API.

    Under heavy loads syslog(3) can block if the syslog daemon processes messages too slowly. This can cause CTDB to block when logging.

    If METHOD is specified then it specifies an extension that causes logging to be done in a non-blocking mode. Note that this may cause messages to be dropped. METHOD must be one of:

    nonblocking

      CTDB will log to syslog via `/dev/log` in non-blocking mode.

    udp

      CTDB will log to syslog via UDP to localhost:514. The syslog daemon must be configured to listen on (at least) localhost:514. Most syslog daemons will log the messages with hostname "localhost" - this is a limitation of the implementation, for compatibility with more syslog daemons.

    udp-rfc5424

      As with "udp" but messages are sent in RFC5424 format. This method will log the correct hostname but is not as widely implemented in syslog daemons.

--max-persistent-check-errors=`NUM`

  NUM specifies the maximum number of health check failures allowed for persistent databases during startup.

  The default value is 0. Setting this to non-zero allows a node with unhealthy persistent databases to startup and join the cluster as long as there is another node with healthy persistent databases.

--nlist=`FILENAME`

  FILENAME containing a list of the private IP addresses, one per line, for each node in the cluster. This file must be the same on each node in the cluster.

  Default is `CTDB_BASE`/nodes, so usually `/usr/local/etc/ctdb/nodes`.

--no-lmaster

  This argument specifies that this node can NOT become an lmaster for records in the database. This means that it will never show up in the vnnmap. This feature is primarily used for making a cluster span across a WAN link and use CTDB as a WAN-accelerator.

  Please see the REMOTE CLUSTER NODES section in ctdb(7) for more information.

--no-recmaster

  This argument specifies that this node can NOT become a recmaster for the database. This feature is primarily used for making a cluster span across a WAN link and use CTDB as a WAN-accelerator.

  Please see the REMOTE CLUSTER NODES section in ctdb(7) for more information.

--notification-script=`FILENAME`

  FILENAME specifying a script to be invoked by ctdbd when certain state changes occur.

  This file is usually `/usr/local/etc/ctdb/notify.sh`.

  Please see the NOTIFICATION SCRIPT section in ctdb(7) for more information.

--pidfile=`FILENAME`

  FILENAME for file containing process ID of main CTDB daemon. This file is automatically created and removed by CTDB.

  The default is to not create a PID file.

--public_addresses=`FILENAME`

  FILENAME specifying a file containing the public IP addresses to use on the cluster when CTDB should use IP takeover. This file contains a list of IP addresses, netmasks and interfaces. CTDB will distribute these public IP addresses appropriately across the available nodes.

  The IP addresses specified in this file can differ across nodes.

  This is usually the file `/usr/local/etc/ctdb/public_addresses`

--public-interface=`INTERFACE`

  Default INTERFACE on which to attach public IP addresses.

  When using public IP addresses, this is only required if interfaces are not explicitly specified in the public addresses file.

--reclock=`LOCK`

  LOCK specifies the cluster-wide mutex used to detect and prevent a partitioned cluster (or "split brain").

  For information about the recovery lock please see the RECOVERY LOCK section in ctdb(7).

--start-as-disabled

  This makes ctdbd start in the DISABLED state.

  To allow the node to host public IP addresses and services, it must be manually enabled using the ctdb enable command.

  Please see the NODE STATES section in ctdb(7) for more information about the DISABLED state.

--start-as-stopped

  This makes ctdbd start in the STOPPED state.

  To allow the node to take part in the cluster it must be manually continued with the the ctdb enable command.

  Please see the NODE STATES section in ctdb(7) for more information about the STOPPED state.

--transport=tcp|infiniband

  This option specifies which transport to use for ctdbd internode communications. The default is "tcp".

  The "infiniband" support is not regularly tested.

-?, --help

  Display a summary of options.

## DEBUGGING OPTIONS

-i, --interactive

  Enable interactive mode. This will make ctdbd run in the foreground and not detach from the terminal. By default ctdbd will detach itself and run in the background as a daemon.

--nopublicipcheck

  This option is used when testing with multiple local daemons on a single machine. It disables checks related to public IP addresses.

--nosetsched

  This is a debugging option. This option is only used when debugging ctdbd.

  Normally ctdbd will change its scheduler to run as a real-time process. This is the default mode for a normal ctdbd operation to gurarantee that ctdbd always gets the CPU cycles that it needs.

  This option is used to tell ctdbd to not run as a real-time process and instead run ctdbd as a normal userspace process. This is useful for debugging and when you want to run ctdbd under valgrind or gdb. (You don't want to attach valgrind or gdb to a real-time process.)

--socket=`FILENAME`

  FILENAME specifies the name of the Unix domain socket that ctdbd will create. This socket is used by local clients to communicate with ctdbd.

  The default is `/usr/local/var/run/ctdb/ctdbd.socket`. You only need to use this option if you plan to run multiple ctdbd daemons on the same physical host, usually for testing.

--script-log-level=`DEBUGLEVEL`

  This option sets the debug level of event script output to DEBUGLEVEL. The default is ERR (0).

  See the DEBUG LEVELS section in ctdb(7) for more information.

--sloppy-start

  This is debugging option. This speeds up the initial recovery during startup at the expense of some consistency checking. Don't use this option in production.

--torture

  This option is only used for development and testing of CTDB. It adds artificial errors and failures to the common codepaths in ctdbd to verify that ctdbd can recover correctly from failures.

  Do not use this option unless you are developing and testing new functionality in CTDB.

--valgrinding

  This is a debugging option. This option is only used when debugging ctdbd. This enables additional debugging capabilities and implies --nosetsched.

## SEE ALSO

ctdb(1), ctdbd_wrapper(1), onnode(1), ctdb(7), ctdb-tunables(7), http://ctdb.samba.org/